type void = unit SMLofNJ.Cont.cont
type 'a K = 'a -> void

val throw: 'a K -> 'a -> 'b =
 fn k => fn t => SMLofNJ.Cont.throw (k t) ()

val callcc: ('a K -> 'a) -> 'a =
 fn t => SMLofNJ.Cont.callcc (fn k => t (fn x => SMLofNJ.Cont.throw k x))

fun Succ (n) = n + 1

fun Pred (n) = if n = 0 then 0 else n - 1

fun Rec (0, x, f) = x
  | Rec (n, x, f) = f (n - 1) (Rec (n - 1, x, f))

